<?php
/**
 * @Copyright
 * @package    EBR - Easybook Reloaded - Latest Entries Module Joomla 3.x - Module
 * @author     Viktor Vogel <admin@kubik-rubik.de>
 * @version    3.2.1 - 2016-08-30
 * @link       https://joomla-extensions.kubik-rubik.de/ebr-easybook-reloaded
 *
 * @license    GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') OR die('Restricted access');

class ModEbrLatestEntriesHelper
{
	function getPosts($params, $gbid)
	{
		$limit = intval($params->get('count'));
		$db = JFactory::getDbo();

		$ids = array_map('trim', explode(',', $params->get('ids')));

		if(!empty($ids[0]))
		{
			$entries = array();

			foreach($ids as $id)
			{
				$query = 'SELECT * FROM '.$db->quoteName('#__easybook').' WHERE '.$db->quoteName('published').' = 1 AND '.$db->quoteName('gbid').' = '.$gbid.' AND '.$db->quoteName('id').' = '.$id.' ORDER BY '.$db->quoteName('gbdate').' DESC';
				$db->setQuery($query);
				$custom_entry = $db->loadAssocList();
				$entries = array_merge($entries, $custom_entry);
			}
		}

		if($params->get('random'))
		{
			$query = 'SELECT * FROM '.$db->quoteName('#__easybook').' WHERE '.$db->quoteName('published').' = 1 AND '.$db->quoteName('gbid').' = '.$gbid.' ORDER BY '.$db->quoteName('gbdate').' DESC';
		}
		else
		{
			$query = 'SELECT * FROM '.$db->quoteName('#__easybook').' WHERE '.$db->quoteName('published').' = 1 AND '.$db->quoteName('gbid').' = '.$gbid.' ORDER BY '.$db->quoteName('gbdate').' DESC LIMIT 0, '.$limit;
		}

		$db->setQuery($query);
		$result = $db->loadAssocList();

		if($params->get('random'))
		{
			shuffle($result);
			$result = array_slice($result, 0, $limit);
		}

		if(!empty($entries))
		{
			$result = array_merge($entries, $result);
		}

		return $result;
	}

	function cutText(&$posts, $length)
	{
		foreach($posts as &$post)
		{
			if(strlen($post['gbtext']) > $length)
			{
				$post['gbtext'] = substr($post['gbtext'], 0, $length);
				$post['gbtext'] .= '...';
			}
		}
	}

	function replaceSmilies(&$posts, $showsmilies, $smiliesset)
	{
		$smiley = EasybookReloadedHelperSmilie::getSmilies();

		foreach($posts as &$post)
		{
			preg_match_all("@\[code.*\].*\[/code\]@isU", $post['gbtext'], $matches);

			$j = 0;

			foreach($matches[0] as $match)
			{
				$post['gbtext'] = str_replace($match, '[codetemp'.$j.']', $post['gbtext']);
				$j++;
			}

			foreach($smiley as $tag => $sm)
			{
				if($showsmilies)
				{
					if($smiliesset == 0)
					{
						$post['gbtext'] = str_replace($tag, "<img src='".JUri::base()."components/com_easybookreloaded/images/smilies/$sm' border='0' alt='$tag' title='$tag' />", $post['gbtext']);
					}
					elseif($smiliesset == 1)
					{
						$post['gbtext'] = str_replace($tag, "<img src='".JUri::base()."components/com_easybookreloaded/images/smilies2/$sm' border='0' alt='$tag' title='$tag' />", $post['gbtext']);
					}
				}
				else
				{
					$post['gbtext'] = str_replace($tag, '', $post['gbtext']);
				}
			}

			$j = 0;

			foreach($matches[0] as $match)
			{
				$post['gbtext'] = str_replace('[codetemp'.$j.']', $match, $post['gbtext']);
				$j++;
			}
		}
	}

	function wordWrap(&$posts, $length)
	{
		foreach($posts as &$post)
		{
			$text = str_replace('<br />', ' ', $post['gbtext']);
			$text_clean = preg_replace('@\s+@', ' ', strip_tags($text));

			$words = explode(' ', $text_clean);

			foreach($words as $value)
			{
				if(strlen($value) > $length)
				{
					$value_cut = wordwrap($value, $length, ' ', true);
					$post['gbtext'] = str_replace($value, $value_cut, $post['gbtext']);
				}
			}

			$post['text_clean'] = $text_clean;
		}
	}

	function bbCode(&$posts)
	{
		$app = JFactory::getApplication();
		$ebconfig = $app->getParams('com_easybookreloaded');

		foreach($posts as &$post)
		{
			$post['gbtext'] = preg_replace('@(\015\012)|(\015)|(\012)@', '<br />', $post['gbtext']);
			EasybookReloadedHelperContent::convertBbCode($post['gbtext'], $ebconfig);
		}
	}

	function noCode(&$posts)
	{
		foreach($posts as &$post)
		{
			$post['gbtext'] = preg_replace("@\[code.*\].*\[/code\]@isU", "<p><strong>[CODE]</strong></p>", $post['gbtext']);
		}
	}

	function validItemID($gbid)
	{
		return EasybookReloadedHelperRoute::getItemId($gbid);
	}

	function entryLink(&$posts, $gbid)
	{
		foreach($posts as &$post)
		{
			$post['entrylink'] = JRoute::_(EasybookReloadedHelperRoute::getEasybookReloadedRoute($post['id'], $gbid));
		}
	}
}
