<?php
/**
 * @Copyright
 * @package    EBR - Easybook Reloaded - Latest Entries Module Joomla 3.x - Module
 * @author     Viktor Vogel <admin@kubik-rubik.de>
 * @version    3.2.1 - 2016-08-30
 * @link       https://joomla-extensions.kubik-rubik.de/ebr-easybook-reloaded
 *
 * @license    GNU/GPL
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined('_JEXEC') OR die('Restricted access');

jimport('joomla.application.component.helper');
$gbid = $params->get('gbid');

if(!JComponentHelper::isEnabled('com_easybookreloaded', true) OR empty($gbid))
{
	if(!JComponentHelper::isEnabled('com_easybookreloaded', true))
	{
		echo JText::_('MOD_EBRLATESTENTRIES_NOCOMP');
	}

	if(empty($gbid))
	{
		echo JText::_('MOD_EBRLATESTENTRIES_NOGB');
	}

	return;
}

require_once(dirname(__FILE__).'/helper.php');

$start = new ModEbrLatestEntriesHelper();

require_once(JPATH_SITE.'/components/com_easybookreloaded/helpers/route.php');

if(!$start->validItemID($gbid))
{
	echo JText::_('MOD_EBRLATESTENTRIES_NOGBMENULINK');

	return;
}

$suffix = $params->get('moduleclass_sfx');
$posts = $start->getPosts($params, $gbid);

if(!empty($posts))
{
	$showname = $params->get('showname');
	$showtitle = $params->get('showtitle');
	$showentrylink = $params->get('showentrylink');
	$showsmilies = $params->get('showsmilies');
	$smiliesset = $params->get('smiliesset');
	$bbcode = $params->get('convertbbcode');
	$showcode = $params->get('showcode');
	$showdate = $params->get('showdate');

	if($params->get('length'))
	{
		$start->cutText($posts, intval($params->get('length')));
	}

	require_once(JPATH_SITE.'/components/com_easybookreloaded/helpers/smilie.php');
	$start->replaceSmilies($posts, $showsmilies, $smiliesset);

	if(!$showcode)
	{
		$start->noCode($posts);
	}

	if($bbcode)
	{
		require_once(JPATH_SITE.'/components/com_easybookreloaded/helpers/content.php');
		$start->bbCode($posts);
	}

	if($params->get('wordlength'))
	{
		$start->wordWrap($posts, intval($params->get('wordlength')));
	}

	if($showname == 2 OR $showentrylink)
	{
		$start->entryLink($posts, $gbid);
	}

	$document = JFactory::getDocument();
	$document->addStyleSheet('modules/mod_ebrlatestentries/ebrlatestentries.css');

	require(JModuleHelper::getLayoutPath('mod_ebrlatestentries'));
}
else
{
	require(JModuleHelper::getLayoutPath('mod_ebrlatestentries', 'empty'));
}

